/*
 *	clipmath.h
 *
 *	Œ菬Cu`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Sat Dec  1 07:12:31 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_MATH_H__
#define __CLIP_MATH_H__

/*****************************************************************************
 *	萔
 *****************************************************************************/

#define PI	3.14159265358979323846F	/*  */
#define PI2	(PI * 2)		/* 2 */
#define PI_2	(PI / 2)		/* /2 */

/*****************************************************************************
 *	xNg
 *****************************************************************************/

/* xNg\܂B
 */
typedef struct _VECTOR {
	float x;	/* X */
	float y;	/* Y */
	float z;	/* Z */
} VECTOR;

/* `ς݂̃xNgłB
 */
extern const VECTOR VECTOR_0;	/* [xNg */
extern const VECTOR VECTOR_X;	/* XPʃxNg */
extern const VECTOR VECTOR_Y;	/* YPʃxNg */
extern const VECTOR VECTOR_Z;	/* ZPʃxNg */

/* xNg쐬܂B
 * [in]
 *	o		ʂi[xNgB
 *	x,y,z		X,Y,Z̒lB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_init(VECTOR* o, float x, float y, float z);

/* xNg̊e𕄍]܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		]xNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_neg(VECTOR* o, const VECTOR* a);

/* xNg̊eZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		ZxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_add(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg̊eZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		ZxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_sub(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg̊eZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		ZxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_mul(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg̊eZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		ZxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_div(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg̊e𓯂lŏZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		ZxNgB
 *	s		ZlB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_mul1(VECTOR* o, const VECTOR* a, float s);

/* xNg̊e𓯂lŏZ܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		ZxNgB
 *	s		ZlB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_div1(VECTOR* o, const VECTOR* a, float s);

/* xNg̓(dot product)߂܂B
 * [in]
 *	a,b		ς߂xNgB
 * [out]
 *	߂l		ς̒lB
 * [note]
 * 	* ς̒`: aEb = |a||b|cos
 */
float vector_dot(const VECTOR* a, const VECTOR* b);

/* xNg̊O(cross product)߂܂B
 * [in]
 *	o		ʂi[xNgB
 *	a,b		Oς߂xNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 * 	* Oς̒`: a~b = |a||b|sin*c
 * 	  AcabɐȒPʃxNgƂB
 */
VECTOR* vector_cross(VECTOR* o, const VECTOR* a, const VECTOR* b);

/* xNg𐳋K(normalize)܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		KxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_normal(VECTOR* o, const VECTOR* a);

/* xNg̒(magnitude)߂܂B
 * [in]
 *	a		߂xNgB
 * [out]
 * 	߂l		ʂ̒lB
 */
float vector_mag(const VECTOR* a);

/* xNg̒̓(square magnitude)߂܂B
 * [in]
 *	a		̓߂xNgB
 * [out]
 * 	߂l		ʂ̒lB
 */
float vector_mag2(const VECTOR* a);

/* ˃xNg߂܂B
 * [in]
 *	o		ʂi[xNgB
 *	N		˖ʂ̖@xNgB
 *	E		˓_ւ̃xNgB
 *			ƁAťxNgłB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* ˃xNǧ́A̒ʂłB
 *		R = 2(EEN)N - E
 *	  l:
 *	  xNgE,N_ƂāAEN֐낵ꍇA
 *	  ̐NƌP_
 *		P = (EEN)N
 *	  łBȂȂA(EEN)̓xNgE,N̂ȂpcoslłB
 *	  ŔAPEɓ_Ώ̂ȈʒuAȂ킿A
 *	  EAE->P̓{i񂾈ʒułB
 *		R = E + 2(P - E)
 *		  = 2P - E
 *		  = 2(EEN)N - E
 *	  ȏłB
 *	* xNgE,ŃAKĂȂ΂܂B
 *	  KĂȂꍇAԈʂƂȂ܂B
 *	  ۂɂ́AEKĂȂꍇ́A
 *	    PɌʂ̃xNg̑傫EɓȂ邾̂悤Ɏv܂B
 *	    (mF)
 *	* xNgÉA"t"xNgł邱ƂɒӂĂB
 *	  ̊֐́A˃xNg߂ƌA
 *	  NƂāAEɐΏ̂ȃxNg߂AƌmłB
 *	  ExNgƓɎg₷Ǝv̂łA
 *	  Ƃċt̕ʓIȂ悤Ȃ̂ŁAȂĂ݂܂B
 */
VECTOR* vector_reflect(VECTOR* o, const VECTOR* N, const VECTOR* E);

/*****************************************************************************
 *	s
 *****************************************************************************/

/* s\܂B
 */
typedef struct _MATRIX {
	/* | a00 a10 a20 |T = pxNgX */
	/* | a01 a11 a21 |T = pxNgY */
	/* | a02 a12 a22 |T = pxNgZ */
	/* | a03 a13 a23 |T = sړ        */
	float a00, a01, a02, a03;
	float a10, a11, a12, a13;
	float a20, a21, a22, a23;
} MATRIX;

/* `ς݂̍słB
 */
extern const MATRIX MATRIX_I;	/* P(identity)s */

/* s쐬܂B
 * [in]
 *	o		ʂi[sB
 *	a00`a23	s̐B
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_init(MATRIX* o,
	float a00, float a01, float a02, float a03,
	float a10, float a11, float a12, float a13,
	float a20, float a21, float a22, float a23);
 
/* ]u(transpose)s߂܂B
 * [in]
 *	o		ʂi[sB
 *	a		]usB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* sړ͏A(0,0,0)ƂȂ܂B
 */
MATRIX* matrix_xpose(MATRIX* o, const MATRIX* a);

/* ts(inverse)߂܂B
 * [in]
 *	o		ʂi[sB
 *	a		ts߂sB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* stȍsw肵ꍇ̌ʂ́A`łB
 */
MATRIX* matrix_inv(MATRIX* o, const MATRIX* a);

/* K(normalized orthogonal)s̋ts߂܂B
 * [in]
 *	o		ʂi[sB
 *	a		ts߂sB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* matrix_inv()AłB
 *	* KłȂsw肵ꍇ̌ʂ́A`łB
 */
MATRIX* matrix_invno(MATRIX* o, const MATRIX* a);

/* xNgϊ(transform)܂B
 * [in]
 *	o		ʂi[xNgB
 *	a		sB
 *	b		xNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
VECTOR* vector_xform(VECTOR* o, const MATRIX* a, const VECTOR* b);

/* sϊ(transform)܂B
 * [in]
 *	o		ʂi[sB
 *	a,b		sB
 *	b00`b23	s̐B
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_xform(MATRIX* o, const MATRIX* a, const MATRIX* b);
MATRIX* matrix_xform12(MATRIX* o, const MATRIX* a,
	float b00, float b01, float b02, float b03,
	float b10, float b11, float b12, float b13,
	float b20, float b21, float b22, float b23);

/*  sړ(translate)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	x,y,z		X,Y,Z̕sړB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_xlate(MATRIX* o, const MATRIX* a, float x, float y, float z);

/* gEk(scale)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	x,y,z		X,Y,Z̊gEkWB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_scale(MATRIX* o, const MATRIX* a, float x, float y, float z);

/* X,Y,ZƂWŁAgEks܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	s		gEkWB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_scale1(MATRIX* o, const MATRIX* a, float s);

/* Cӎ](rotate)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	x,y,z		]̃xNgB
 *	d		]pxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* ]̃xNǵAKĂȂĂ\܂B
 */
MATRIX* matrix_rot(MATRIX* o, const MATRIX* a, float x, float y, float z, float d);

/* Œꎲ](rotate)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	d		]pxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_rotx(MATRIX* o, const MATRIX* a, float d);
MATRIX* matrix_roty(MATRIX* o, const MATRIX* a, float d);
MATRIX* matrix_rotz(MATRIX* o, const MATRIX* a, float d);

/* Œ񎲉](rotate)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	x,y,z		]pxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* O̉]pxw̌ʂ͋tłB
 *	  ŒO][note]QƂĂB
 */
MATRIX* matrix_rotxyx(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotxzx(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotyxy(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotyzy(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotzxz(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotzyz(MATRIX* o, const MATRIX* a, float x, float y, float z);

/* ŒO](rotate)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	x,y,z		]pxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* s]ûŁAťʂɂȂ܂B
 *	  Ⴆ΁A
 *		matrix_rotxyz(o, a, x, y, z)
 *	  ́A
 *		matrix_rotz(o, a, z);
 *		matrix_roty(o, o, y);
 *		matrix_rotx(o, o, x);
 *	  ƓʂƂȂ܂B
 *	  ֐̖Oς̂m܂񂪁A
 *	  őɎgȂ̂ŁAƂ肠̂܂܂ɂĂ܂B
 */
MATRIX* matrix_rotxyz(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotxzy(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotyxz(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotyzx(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotzxy(MATRIX* o, const MATRIX* a, float x, float y, float z);
MATRIX* matrix_rotzyx(MATRIX* o, const MATRIX* a, float x, float y, float z);

/* ]̃xNgƁA]px߂܂B
 * [in]
 *	v		]̃xNgi[xNgB
 *	a		ׂsB
 * [out]
 *	߂l		]pxB
 */
float matrix_rotget(VECTOR* o, const MATRIX* a);

/* pϊ(orientate)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	dx,dy,dz	Z̎pxNgB
 *	ux,uy,uz	Y̎pxNgB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* pxNǵAKĂȂĂ\܂B
 */
MATRIX* matrix_orient(MATRIX* o, const MATRIX* a,
	float dx, float dy, float dz,
	float ux, float uy, float uz);

/* _ϊs܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	ex,ey,ez	_WB
 *	cx,cy,cz	_WB
 *	bank		oNpxB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_lookat(MATRIX* o, const MATRIX* a,
	float ex, float ey, float ez,
	float cx, float cy, float cz,
	float bank);

/* ϊ(frustum)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	width		eʂ̕              (Wn)
 *	height		eʂ̍            (Wn)
 *	front		tgNbsO(Wn)
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* Sȓϊł͂ȂAZW͎Ŵ܂ܕω܂B
 *	  ȂȂÃCuł͍s3x4ŕ\Ă̂ŁA
 *	  ZW̐Klϊs\ȂłB
 *	  Azobt@ł͂ȂAz\[gz肵Ă̂ŁA
 *	  p͂ȂƎv܂B
 *	* ̍sōWϊł́AX,YW͐K܂B
 *	  x=x/z,y=y/z sāAx,y(-1,1)ɓeKv܂B
 */
MATRIX* matrix_frustum(MATRIX* o, const MATRIX* a, float width, float height, float front);

/* ϊ(perspective)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	fovy		pxB
 *	aspect		AXyNg()
 *	front		tgNbsO(Wn)
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* matrix_frustum()̃RgQƂĂB
 */
MATRIX* matrix_perspect(MATRIX* o, const MATRIX* a, float fovy, float aspect, float front);

/* r[|[gϊ(viewport)s܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	left,top	r[|[g_W(XN[Wn)
 *	width,height	r[|[gTCY  (XN[Wn)
 *			^͌Œ菬ł͂Ȃł邱Ƃ
 *			  ӂĂB
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 * [note]
 *	* ϊ -> x=x/z,y=y/z -> r[|[gϊ
 *	  ̏œKpꍇ́Amatrix_viewport()gĂB
 *	* ϊ -> r[|[gϊ -> x=x/z,y=y/z
 *	  ̏œKpꍇ́Amatrix_viewportz()gĂB
 *	* matrix_viewport()gWϊ̎菇́ÂƂłB
 *		1. T = fϊ * _ϊ * ϊ ɂWϊ
 *		2. ZNbsO
 *		3. x = x / z, y = y / z
 *		4. T = r[|[gϊ ɂWϊ
 *		5. XYNbsO
 *	* ɑ΂Amatrix_viewportz()gꍇ́A
 *		1. T = fϊ * _ϊ * ϊ * r[|[gϊ
 *	  	   ɂAWϊ
 *		2. ZNbsO
 *		3. x = x / z, y = y / z
 *		4. XYNbsO
 *	  ƂȂA菇炷Ƃł܂B
 */
MATRIX* matrix_viewport(MATRIX* o, const MATRIX* a, int left, int top, int width, int height);
MATRIX* matrix_viewportz(MATRIX* o, const MATRIX* a, int left, int top, int width, int height);

/* eϊs܂B
 * [in]
 *	o		ʂi[sB
 *	a		sB
 *	Lx,Ly,Lz	xNg
 *	Gx,Gy,Gz	eʏ̈_(C)̍W
 *	Nx,Ny,Nz	eʂ̖@xNg
 * [out]
 *	߂l		o̒l̂܂ܕԂ܂B
 */
MATRIX* matrix_shadow(MATRIX* o, const MATRIX* a,
	float Lx, float Ly, float Lz,
	float Gx, float Gy, float Gz,
	float Nx, float Ny, float Nz);

/*****************************************************************************
 *	Z[eBeB
 *****************************************************************************/

/* _璼֐낵ʒúAp[^߂܂B
 * [in]
 *	p	_̍WB
 *	a	̎n_WB
 *	da	̃xNgB
 * [out]
 *	߂l	ɐ肽ʒu\Ap[^B
 * [note]
 *	* 𔼒ƌȂꍇAɉ肽肷ɂ:
 *		da𔼒̂̂тւ̃xNgƂs߁A
 *			0 <= s
 *		ȂΔɐB
 *	* ƌȂꍇAɉ肽肷ɂ:
 *		da̎n_I_ւ̃xNgƂs߁A
 *			0 <= s && s < 1
 *		ȂΐɐB
 *	* ۂ̈ʒu q ߂ɂ: q = a + da A
 *		s = point_to_line_s(p, a, da);
 *		vector_mul_1(das, da, s);
 *		vector_add(q, a, das);
 *	* _璼ւ̋߂ɂ: l = |pq| A
 *		vector_sub(pq, q, p);
 *		l = vector_magnitude(pq);
 */
float point_to_line_s(const VECTOR* p, const VECTOR* a, const VECTOR* da);

/* xWFȐ(̈ꐬ)vZ܂B
 * [in]
 *	t	pgbNϐ(0.0`1.0)B
 *	Q0	Rg[|Cg#0̍WB
 *	Q1	                    #1
 *	Q2	                    #2
 * [out]
 *	߂l	P(t)̍WlB
 * [note]
 *	* Rg[|Cg->AJ[|CgƌĂԂ̂? (mF)
 */
float bezier1(float t, float Q0, float Q1, float Q2);

/* G~[gȐ(̈ꐬ)vZ܂B
 * [in]
 *	t	pgbNϐ(0.0`1.0)B
 *	Q0	Rg[|Cg#0̍WB
 *	Q1	                    #1
 *	Q0d	Rg[|Cg#0ɂړ_xNgB
 *	Q1d	                    #1
 * [out]
 *	߂l	P(t)̍WlB
 * [note]
 *	* G~[gȐ́Aړ_xNg̑傫ɂĕω܂B
 *	  ܂Aړ_xNg̑傫ɂӖ邽߁A
 *	  ɐړ_xNg𐳋KĂ͂܂B
 *	* ̊֐́AꐬvZ܂B
 *	  Ⴆ΁A3ȐɓKpꍇ́A3gĂB
 *	* f[^ƂăRg[|Cg̍WA
 *	  ړ_xNgȂƂ́Â悤ɂĐĂB
 *		Qnɂړ_xNg = Qn' = a * (Q(n+1) - Q(n-1))
 *		a͔Cӂ̒萔A0.5OオʓI? (mF)
 *	  Ȃ킿AO̓_xNg߁AɈ芄܂B
 *	* W=ԑΏہAړ_xNg=ԑΏۂ̕ω Ƃ݂Ȃ΁A
 *	  ȐȊOɂpł܂B
 */
float hermite1(float t, float Q0, float Q1, float Q0d, float Q1d);

/* _}`̓ɂ邩Oɂ邩𒲂ׂ܂B
 * [in]
 *	px, py		ׂ_̍WB
 *	points		}`̒_XgB
 *	n_points	_̐B
 * [out]
 *	߂l		ȂA0ȊO̒lԂ܂B
 *			OȂA0        Ԃ܂B
 * [note]
 *	* }`́Aʌ^łȂA^ɂΉĂ܂B
 *	* }`̕ӂꍇA̐}`ƌȂ܂B
 *	  XSetFillRules()ɗႦȂ΁AEvenOddRuleɑ܂B
 *	  WindingRuleł̃`FbN@́Â݂Ƃ񋟂Ă܂B
 */
int point_in_polygon(float px, float py, float points[/*n_points*/][2], int n_points);

/* Q̌_߂܂B
 * [in]
 *	(x1   ,y1   )	1̎n_B
 *	(x1end,y1end)	1̏I_B
 *	(x2   ,y2   )	2̎n_B
 *	(x2end,y2end)	2̏I_B
 *	(px   ,py   )	ʂ̌_W󂯎ϐւ̃|C^B
 * [out]
 *	߂l		QĂA1Ԃ܂B
 *			QĂȂ΁A0Ԃ܂B
 *	(*px  , *py )	QĂA_̍Wi[܂B
 *			QĂȂ΁Â܂܂̒lێ܂B
 * [note]
 *	* QĂ邩ǂ𒲂ׁA_WKvȂꍇ́A
 *	  pxpyNULLw肵ĂB
 */
int cross_point(float x1, float y1, float x1end, float y1end,
		float x2, float y2, float x2end, float y2end,
		float* px, float* py);

/* _֐낵ʒúA_W߂܂B
 * [in]
 *	(x1   ,y1   )	_@̍WB
 *	(x2   ,y2   )	̎n_B
 *	(x2end,y2end)	̏I_B
 *	(px   ,py   )	ʂ̌_W󂯎ϐւ̃|C^B
 * [out]
 *	߂l		_ɂ΁A1Ԃ܂B
 *			_ɂȂ΁A0Ԃ܂B
 *	(*px  , *py )	_ɂ΁A_̍Wi[܂B
 *			_ɂȂ΁Â܂܂̒lێ܂B
 * [note]
 *	* _ɂ邩ǂ𒲂ׁA_WKvȂꍇ́A
 *	  pxpyNULLw肵ĂB
 */
int ortho_point(float x1, float y1,
		float x2, float y2, float x2end, float y2end,
		float*px, float* py);

/* }`̋LqE肩肩𒲂ׂ܂B
 * [in]
 *	points		}`̒_XgB
 *	n_points	_̐B
 * [out]
 *	߂l		EȂ0ȊO̒lԂ܂B
 *			Ȃ0        Ԃ܂B
 * [note]
 *	* ^|SɂΉĂ܂B
 *	* WńAEX+AY+Ƃ܂B
 *	  łȂꍇA߂l͋ẗӖƂȂ܂B
 */
int polygon_orient(float points[/*n_points*/][2], int n_points);

/* 捪߂܂B
 * [in]
 *	x, n		nx
 * [out]
 *	߂l		x̂捪Ԃ܂B
 * [note]
 *	* {́AWbCupow()֐gāupow(x,1/n)vƂ邾ŁA
 *	  捪߂̂łA̗Rɂ֐`܂B
 *	* RPFP/ECEtCupow()֐͓삪B(->clipstd.hQ)
 *	          clipstd.hpow()Ē`ĉĂ܂AÔ߂łB
 *	* RQFl捪vZ@YȂ悤(^^; {̖ړIB
 *	* ֐́A
 *	    ZpvZpbvO\[X(http://www5.airnet.ne.jp/tomy/cpro/csource.htm)
 *	    -> {_ZCu(http://www5.airnet.ne.jp/tomy/cpro/mpa.htm)
 *	    -> wEΐEׂ֐[`(http://www5.airnet.ne.jp/tomy/cpro/mp8.htm)
 *	  ɗR܂B
 */
float x1n(float x, float n);

/*****************************************************************************
 *	Z[eBeB
 *****************************************************************************/

/* 32rbgȂ̕߂܂B
 * [in]
 *	a		߂lB
 * [out]
 *	߂l		B
 * [note]
 *	* aɕlw肵Ă͂܂B
 *	  aɕlw肵ꍇ̌ʂ́AӖȒlƂȂ܂B
 *	* ߂ĺA0x0000`0xffff͈̔͂łB
 *	  a0xffff^2ȏ̒lw肵ĂAʂ0xffffƂȂ܂B
 */
int sqrt_32(int a);

/* 邤N𔻒肵܂B
 * [in]
 *	year		N(4ŎwB2002Ȃ)
 * [out]
 *	߂l		w肳ꂽN邤NȂ1A
 *			邤NłȂ0Ԃ܂B
 */
int leapyear(int year);

/* cF[̌gāANj߂܂B
 * [in]
 *	year		N(1583`3999)
 *	month		(1`12)
 *	day		(1`31)
 * [out]
 *	߂l		j(0:/1:/2:/3:/4:/5:/6:y)
 * [note]
 *	* cF[̗̌L͈͂́A1583N`3999N܂łłB
 *	  (ɂ́A1582N1015ȍ~łB)
 *	  ͈̔͊Ow肵ꍇAԈʂԂ܂B
 */
int dayofweek(int year, int month, int day);

/*****************************************************************************
 *	Z[eBeB̐o[W
 *****************************************************************************/

/* Z[eBeB̈ꕔɂāAo[Wpӂ܂B
 * {IɁÃR[hRs[āAfloat->intɒułB
 * ߂lɂẮAo[W̐QƂĂB
 * o[WCꍇ́Ao[WǏ]ĂB
 */

int point_in_polygon_32(int px, int py, int points[/*n_points*/][2], int n_points);

int cross_point_32(int x1, int y1, int x1end, int y1end,
		   int x2, int y2, int x2end, int y2end,
		   int* px, int* py);

int ortho_point_32(int x1, int y1,
		   int x2, int y2, int x2end, int y2end,
		   int*px, int* py);

#endif /*__CLIP_MATH_H__*/
