/*
 *	dat.c
 *
 *	datt@C̓[`
 *
 *	* Dec Fri 13 21:16:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	
 ****************************************************************************/

static void
trim_left(char* str)
{
	int len = strlen(str);
	while(isspace(str[0])) {
		memmove(str, str + 1, len--/*I[ƈړ̂ŁA|XgfNg*/);
	}
}

static void
trim_right(char* str)
{
	int len = strlen(str);
	while(isspace(str[len - 1])) {
		str[--len] = '\0';
	}
}

static void
trim(char* str)
{
	trim_left(str);
	trim_right(str);
}

/****************************************************************************
 *	dat
 ****************************************************************************/

/* ŏɈ񂾂Ăԏ */
int
dat_init1(DAT* dat, const char* fname)
{
	/* ܂mɃt@C܂B */
	dat_free(dat);

	/* SoϐNAB */
	memset(dat, 0, sizeof(DAT)); /* line_ofs[0] <- 0 ˂܂ */

	/* t@CJ܂B */
	dat->fp = fopen(fname, "rb");
	if(dat->fp == NULL) return -1;

	return 0;
}

/* UI񂵂Ȃ珇 */
int
dat_init2(DAT* dat, int count)
{
	int i;

	/* Ȏ̓ǂݍ݈ʒu𕜌܂B */
	fseek(dat->fp, dat->init_pos, SEEK_SET);

	/* es̈ʒu߂܂B */
	for(i = 0; i < count; i++) {
		if(dat->n_lines == MAX_LINES) break;
		if(fgets(dat->line, LINE_SIZE, dat->fp) == NULL) break;
		dat->line_ofs[++dat->n_lines] = ftell(dat->fp); /* line_ofs[i+1] <- sȉI[ItZbg */
	}

	/* ̂߂ɓǂݍ݈ʒuۑ܂B */
	dat->init_pos = ftell(dat->fp);

	return i; /* VsԂBȂ0ԂB */
}

void
dat_free(DAT* dat)
{
	/* t@CJĂA܂B */
	if(dat->fp != NULL) {
		fclose(dat->fp);
		dat->fp = NULL;
	}
}

static void
dat_line(DAT* dat, int i_line)
{
	int retval, ofs, len;

	/* w肳ꂽsǂݍ݂܂B */
	if(i_line < 0 || dat->n_lines - 1 < i_line) DIE();
	ofs = dat->line_ofs[i_line];
	len = dat->line_ofs[i_line + 1] - ofs;
	fseek(dat->fp, ofs, SEEK_SET);
	retval = fread(dat->line, 1, len, dat->fp);
	if(retval != len) DIE();
	dat->line[len] = '\0'; /* dvIYȂ */

	/* ̉s폜܂B(łɑŐ󔒂) */
	trim(dat->line);

	/* |C^擪ɖ߂܂B */
	dat->pos = dat->line;
}

typedef struct _AMP {
	char code;
	const char* name;
} AMP;
static const AMP amp[] = {
	{ ' ',"nbsp"},
	{'"',"quot"},
	{'&',"amp"},
	{'<',"lt"},
	{'>',"gt"},
};

static int
dat_char(DAT* dat, int ignore_space)
{
	int i, len;
	char code;

	/* ꕶ擾B */
	do {
		code = *dat->pos++;
	} while(ignore_space && isspace(code));

	/* u</b>vAu<a href="...">vȂ */
	if(code == '<') {
		dat->tag = dat->pos;
		while((code = *dat->pos) != '>') {
			if(code == '\0') return C_ERR;
			dat->pos++;
		}
		*dat->pos++ = '\0';
		return C_TAG;
	}

	/* u&amp;vAu&lt;vȂ
	 * {̒ɒځu&v邱Ƃ̂ŁAvȂ΂̂܂܎g܂B
	 *   ɁA{ɏꂽURĹACGI&u&amp;vɂȂ炸u&v̂܂܌悤łB
	 *   {{
	 *     ftHg̖<>sage<>02/03/05 16:15<>
	 *     [ށB̂.datȂǂ߂ȂǁA<br>
	 *     http://pc.2ch.net/test/read.cgi?bbs=tech&key=/../kako/1003/10032/1003222181<br>
	 *     .dat邩ǂ߂肵āB<br>
	 *     http://mentai.2ch.net/test/read.cgi?bbs=mukashi&key=/../accuse/kako/952/952147466&raw=.0<>
	 *   }}
	 *   Ȃu&amp;vɂȂ̂AsłB
	 */
	if(code == '&') {
		for(i = 0; i < sizeof amp / sizeof *amp; i++) {
			len = strlen(amp[i].name);
			if(memcmp(dat->pos, amp[i].name, len) == 0 &&
			   dat->pos[len] == ';') {
				dat->pos += len + 1;
				return amp[i].code;
			}
		}
		/* p */
	}

	/* oCg */
	if(ismbblead(code)) {
		if(!ismbbtrail(*dat->pos)) return C_ERR;
		return (code & 0xff) << 8 | (*dat->pos++ & 0xff);
	}

	return code & 0xff;
}

/****************************************************************************
 *	mess
 ****************************************************************************/

static int
mess_init_sub(char* buff, int size, DAT* dat)
{
	int i, code;

	i = 0;
	for(;;) {
		code = dat_char(dat, 0); /* r̋󔒕͖ȂAŐ󔒂͍ŌɎ菜 */
		if(code == '\0') break; /* code='\0'ŏI */
		if(code == C_ERR) return C_ERR;
		if(code == C_TAG) {
			if(strcmp(dat->tag, "") == 0) {
				break; /* <> ... code=C_TAGŏI */
			} else {
				continue; /* ȊÕ^O͖ */
			}
		}
		if(code > 0xff) { /* 2oCg */
			if(i + 2 <= size) {
				buff[i++] = code >> 8 & 0xff;
				buff[i++] = code      & 0xff;
			} else {
				i = size; /* ̌A]v1oCgǉȂ悤 */
			}
		} else { /* 1oCg */
			if(i + 1 <= size) {
				buff[i++] = code;
			}
		}
	}
	trim(buff); /* Ő󔒂菜 */

	return code;
}

int
mess_init(MESS* mess, DAT* dat, int i_line)
{
	int col, row, code;
	/* AJ[̓tF[YF
	 * 0:AJ[O
	 * 1:">"
	 * 2:">>"
	 * 3:">>[1-9]"
	 * 4:">>[1-9][0-9]*"
	 * <a href="">URL̓XbhɂċKႤ̂ŁAURLł͂Ȃ{𒼐ډ͂܂B
	 * AJ[I^O͓ʈȂ̕ɂAJ[IƓɏ܂B
	 */
	int anchor_phase = 0;

	memset(mess, 0, sizeof(MESS));

	/* sǂݍ݁B */
	dat_line(dat, i_line);

	/* OE[E */
	if(mess_init_sub(mess->name, NAME_SIZE, dat) != C_TAG) goto ERR;
	if(mess_init_sub(mess->mail, MAIL_SIZE, dat) != C_TAG) goto ERR;
	if(mess_init_sub(mess->time, TIME_SIZE, dat) != C_TAG) goto ERR;

	/* { */
	col = 0;
	row = 0;
	for(;;) {
		code = dat_char(dat, 1); /* {̋󔒕͑SĖ */
		if(code == '\0') goto ERR;
		if(code == C_ERR) goto ERR;
		/* AJ[́B */
		switch(anchor_phase) {
		case 1:
			if(code == '>') {
				anchor_phase = 2;
			} else if(!isspace(code)) { /* u<a href="">vƁu>>123v̊Ԃ̋󔒕͋eĂ݂iȂƂȂj */
				anchor_phase = 0;
			}
			break;
		case 2:
			if(code == '>') {
				anchor_phase = 3;
			} else {
				anchor_phase = 0;
			}
			break;
		case 3:
			if('1' <= code && code <= '9') {
				mess->anchors[mess->n_anchors].mess = code - '0';
				anchor_phase = 4;
			} else {
				anchor_phase = 0;
			}
			break;
		case 4:
			if('0' <= code && code <= '9') {
				mess->anchors[mess->n_anchors].mess =
				mess->anchors[mess->n_anchors].mess * 10 + (code - '0');
				/* tF[Y4p */
			} else {
				if(1 <= mess->anchors[mess->n_anchors].mess && mess->anchors[mess->n_anchors].mess <= MAX_LINES) {
					mess->anchors[mess->n_anchors].mess--; /* bZ[Wԍ -> CfNX ϊĂ܂ */
					mess->anchors[mess->n_anchors].col2 = col;
					mess->anchors[mess->n_anchors].row2 = row;
					mess->n_anchors++; /* LȃAJ[m肵̂ŁAAJ[JEgAbv܂ */
				}
				anchor_phase = 0;
			}
			break;
		}
		/* ^OA܂́Ai[B */
		if(code == C_TAG) {
			if(strcmp(dat->tag, "") == 0) {
				break; /* <>Ŗ{I */
			} else if(strcmp(dat->tag, "br") == 0) { /* s */
				if(col > 0) { /* s͍Ȃ */
					col = 0;
					row++;
				}
			} else if(strncmp(dat->tag, "a ", 2) == 0) { /* AJ[Jn("<a "܂ňvOK) */
				if(mess->n_anchors < MAX_ANCHORS) {
					anchor_phase = 1; /* AɊJnĂAO̊Jn͖ */
					mess->anchors[mess->n_anchors].col1 = col;
					mess->anchors[mess->n_anchors].row1 = row;
					/* ܂AJ[̓JEgAbv܂BƂɃJEgAbv܂B */
				}
			} else {
				/* Ή^O */
			}
		} else if(code > 0xff) { /* 2oCg */
			if(col + 2 > TEXT_COLS) {
				col = 0;
				row++;
			}
			if(row < TEXT_ROWS) {
				mess->text[row][col++] = code >> 8 & 0xff;
				mess->text[row][col++] = code      & 0xff;
				if(col == TEXT_COLS) {
					col = 0;
					row++;
				}
			}
		} else { /* 1oCg */
			if(row < TEXT_ROWS) {
				mess->text[row][col++] = code;
				if(col == TEXT_COLS) {
					col = 0;
					row++;
				}
			}
		}
	}
	if(col > 0) {
		col = 0;
		row++;
	}
	mess->n_rows = row;

	/* ^Cg */
	if(mess_init_sub(mess->title, TITLE_SIZE, dat) != '\0') goto ERR;

	return 0;

ERR:
	memset(mess, 0, sizeof(MESS));
	/*                          01234567890123456789012345678901 */
	strncpy(&mess->text[0][0], "ĩbZ[W͉Ă܂j", TEXT_COLS);
	mess->n_rows = 1;
	return -1;
}
