/*
 *	main.c
 *
 *	Q˂郍Or[A
 *
 *	* Dec Fri 13 21:16:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */
SURFACE surface;			/* zVRAM̃T[tFCX */
RENDER render;				/* zVRAMւ̕` */

int now;				/* O[o^C} */
int joy;				/* pbh */

typedef struct _FILESELITEM {
	char fname[MAXFILENAME + 1];	/* t@C */
	char title[TITLE_SIZE + 1];	/* Xbh^Cg */
} FILESELITEM;
int n_file_sel_items;			/* t@CI̐ */
FILESELITEM file_sel_items[MAXDIR];	/* t@CI */

DAT dat;
MESS mess;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int file_sel_init();
int file_sel(int sel);
void dat_view();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	int sel;

	/* B */
	app_init();

	/* t@CIB */
	if(file_sel_init() == 0) die("DATt@C܂");

	/* ŏ̃t@CIԂɂĂ܂B */
	sel = 0;
	if(dat_init1(&dat, file_sel_items[sel].fname) != 0) DIE();

	for(;;) {
		/* t@CIB */
		sel = file_sel(sel);
		if(sel < 0) break;

		/* DAT\B */
		dat_view();
	}

	return 0;
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pcePadSetTrigMode(PP_MODE_SINGLE); /* OŃI[gs[g -> schedule() */
	pceLCDDispStart();

	/* `B */
	surface.w = DISP_X;
	surface.h = DISP_Y;
	surface.vbuff = vbuff;
	render_init(&render, &surface, 0, 0, 0, 0, 0, 0, 0);

	/* ktHg`̎܂Ԃ}܂B */
	sFontStatus.xMin = -9999;
	sFontStatus.yMin = -9999;
	sFontStatus.xMax =  9999;
	sFontStatus.yMax =  9999;
	/* x,y,spr͐؂芷܂B */

	/* N[Abv֐o^B */
	atexit(app_exit);
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	pceLCDTrans();		/* ʍXV */
	yield();		/* VXe */
	joy = pcePadGet();	/* pbhԍXV */
	now++;			/* O[o^C}XV */

	if(dat.fp != NULL) dat_init2(&dat, 1); /* 񓯊DAT */

	/* ㉺EL[I[gs[gAȊO̓I[gs[gȂB */
	{
		static unsigned char cnt[4];
		int i;
		for(i = 0; i < 4; i++) {
			if(joy & (0x01 << i)) {
				if(cnt[i] != 0xff) cnt[i]++;
				if(cnt[i] >= SEC(0.5)) joy |= (0x100 << i);
			} else {
				cnt[i] = 0;
			}
		}
	}
}

/****************************************************************************
 *	file_sel_init
 ****************************************************************************/

int
file_sel_init()
{
	FILEINFO fi;

	/* ܂mɑIACeɂ܂B */
	n_file_sel_items = 0;
	memset(file_sel_items, 0, sizeof file_sel_items);

	/* St@C𑖍...(gq́u.datvɌ肵܂!) */
	pceFileFindOpen(&fi);
	while(n_file_sel_items < MAXDIR && pceFileFindNext(&fi)) {
		/* ^Cg擾łADATt@CƌȂ܂B */
		if(dat_init1(&dat, fi.filename) != 0) continue;
		if(dat_init2(&dat, 1) != 1) continue;
		if(mess_init(&mess, &dat, 0) != 0) continue;
		/* IACeɒǉB */
		strncpy(file_sel_items[n_file_sel_items].fname, fi.filename, MAXFILENAME);
		strncpy(file_sel_items[n_file_sel_items].title, mess.title, TITLE_SIZE);
		n_file_sel_items++;
	}
	pceFileFindClose(&fi);

	/* IACe̐Ԃ܂B(O[oϐɂɃZbgĂ邯) */
	return n_file_sel_items;
}

/****************************************************************************
 *	file_sel
 ****************************************************************************/

int
file_sel(int sel)
{
	int i, sel_old, top, row;

	sel_old = sel; /* dat_init1(sel)ĂƑz */
	top = 0;
	for(;;) {
		schedule();

		/* ELZB */
		if(joy & TRG_A) return sel;
		if(joy & TRG_SELECT) return -1;

		/* t@CIB */
		if(joy & TRG_UP) sel--;
		if(joy & TRG_DN) sel++;
		if(joy & TRG_LF) sel -= 8;
		if(joy & TRG_RI) sel += 8;
		if(sel < 0) sel = 0;
		if(sel > n_file_sel_items - 1) sel = n_file_sel_items - 1;
		if(sel != sel_old) {
			sel_old = sel;
			if(dat_init1(&dat, file_sel_items[sel].fname) != 0) DIE();
		}
		if(sel < top) top = sel;
		if(sel > top + 7) top = sel - 7;

		/* I𒆂̃t@CƃbZ[W\B */
		render_rectangle_fill(&render, 0, 0, DISP_X, 7, 3);
		render_printf(&render, 1, 1, 2, 0, "%-12s (%4d)", file_sel_items[sel].fname, dat.n_lines);

		/* ^CgXg\B */
		render_rectangle_fill(&render, 0, 7, DISP_X, DISP_Y - 7, 0);
		for(i = 0; i < 8; i++) {
			row = top + i;
			if(row > n_file_sel_items - 1) break;
			sFontStatus.x = 0;
			sFontStatus.y = 8 + i * 10;
			sFontStatus.spr = row == sel ? 2 : 0;
			sFontPrintf("%*d:%s",
				n_file_sel_items < 10 ? 1 : 2, /* CfNX̌ */
				row + 1,
				file_sel_items[row].title);
		}
	}

	return 0;
}

/****************************************************************************
 *	dat_view
 ****************************************************************************/

#define HISTORY_SIZE	MAX_LINES
static int history[HISTORY_SIZE];

void
dat_view()
{
	int i, j, sel, sel_old, top, i_anchor, under_line, col, row, x, y, code, code2;
	char* p;
	ANCHOR* anchor;

	/* ȂƂ1bZ[W͗pӂĂ܂B */
	if(dat.n_lines == 0 && dat_init2(&dat, 1) != 1) DIE();
	sel_old = sel = 0;
	top = 0;
	i_anchor = 0;
	mess_init(&mess, &dat, sel); /* s͖ */
	memset(history, 0, sizeof history);

	for(;;) {
		schedule();

		/* Xbh\IH */
		if(joy & TRG_SELECT) return;

		/* bZ[WIB */
		if(joy & TRG_LF && sel > 0) sel--;
		if(joy & TRG_RI && sel < dat.n_lines - 1) sel++;
		if(joy & TRG_A) { /* AJ[Wv */
			if(mess.n_anchors != 0 &&
			   mess.anchors[i_anchor].mess < dat.n_lines) {
				sel = mess.anchors[i_anchor].mess;
			}
		}
		if(joy & TRG_B) { /* ߂ */
			memmove(&history[0], &history[1], sizeof(*history) * (HISTORY_SIZE - 1));
			history[HISTORY_SIZE - 1] = 0;
			sel = history[0];
			if(sel != sel_old) goto NO_HISTORY_STORE; /* ܎o΂̗܂ǉĂ܂Ȃ悤 */
		}
		if(sel != sel_old) {
			memmove(&history[1], &history[0], sizeof(*history) * (HISTORY_SIZE - 1));
			history[0] = sel;
NO_HISTORY_STORE:
			sel_old = sel;
			top = 0;
			i_anchor = 0;
			mess_init(&mess, &dat, sel); /* s͖ */
		}

		/* bZ[WXN[B */
		if(joy & TRG_UP && top > 0) top--;
		if(joy & TRG_DN && top < mess.n_rows - 8) top++;

		/* AJ[IB */
		if(joy & TRG_START && mess.n_anchors != 0) {
			i_anchor = (i_anchor + 1) % mess.n_anchors;
			/* IꂽAJ[̊JnʒuʊOAł邾ɕ\悤ɃXN[B(w3m[TAB]̋Qlɂ܂) */
			row = mess.anchors[i_anchor].row1;
			if(row < top || top + 7 < row) {
				top = row;
				if(top > mess.n_rows - 8) top = mess.n_rows - 8;
				if(top < 0) top = 0; /* bZ[W8s̏ꍇ̏Ȃ̂ŁAifelse߂ɓꂿ_I */
			}
		}

		/* bZ[WԍƓe\B */
		render_rectangle_fill(&render, 0, 0, DISP_X, 7, 3);
		x = 1;
		y = 1;
		x += render_printf(&render, x, y, 2, 0, "%4d/%4d", sel + 1, dat.n_lines) & 0xffff;
		x += 4; /* bZ[Wԍ`eԂ̃}[W */
		i = 0;
		while(x < DISP_X - 12) {
			code = mess.time[i++];
			if(code == '\0') break; /* KvBstrchr(" /:", '\0')" /:"̖'\0'ɈvĔk|C^Ԃ!!istrchr()̐U镑łj */
			if(!(isdigit(code) || strchr(" /:", code))) break;
			x += render_font(&render, x, y, code, 2, 0) & 0xff;
		}
		if(top > 0) { /* XN[\Ȃ\ */
			render_point(&render, DISP_X - 3, 1, 0);
			render_point(&render, DISP_X - 4, 2, 0);
			render_point(&render, DISP_X - 3, 2, 0);
			render_point(&render, DISP_X - 2, 2, 0);
		}
		if(top < mess.n_rows - 8) { /* XN[\Ȃ牺\ */
			render_point(&render, DISP_X - 3, 5, 0);
			render_point(&render, DISP_X - 4, 4, 0);
			render_point(&render, DISP_X - 3, 4, 0);
			render_point(&render, DISP_X - 2, 4, 0);
		}

		/* {\B */
		render_rectangle_fill(&render, 0, 7, DISP_X, DISP_Y - 7, 0);
		y = 8;
		for(i = 0; i < 8; i++) {
			row = top + i;
			if(row > mess.n_rows - 1) break;
			col = 0;
			x = 0;
			for(p = &mess.text[row][0]; (code = *p) != '\0'; p++) {
				/* AJ[B */
				sFontStatus.spr = 0;
				under_line = 0;
				for(anchor = mess.anchors, j = 0; j < mess.n_anchors; j++, anchor++) {
					if((anchor->row1 << 16 | anchor->col1) <= (row << 16 | col) &&
					   (anchor->row2 << 16 | anchor->col2) >  (row << 16 | col)) {
						if(j == i_anchor) {
							sFontStatus.spr = 2; /* IAJ[Ȃ甽]\ */
						} else {
							under_line = 1; /* IAJ[ȂA_[C */
						}
					}
				}
				/* ꕶ`B */
				if(ismbblead(code)) { /* 2oCg */
					code2 = *++p;
					if(!ismbbtrail(code2)) DIE(); /* dat_char()Ōς݂̂͂ */
					code = (code & 0xff) << 8 | (code2 & 0xff);
					sFontPut(x, y, code);
					if(under_line) render_line(&render, x, y + 9, x + 8, y + 9, 3);
					col += 2;
					x += 8;
				} else { /* 1oCg */
					code &= 0xff; /* Kv!! */
					sFontPut(x, y, code);
					if(under_line) render_line(&render, x, y + 9, x + 4, y + 9, 3);
					col += 1;
					x += 4;
				}
			}
			y += 10;
		}
	}
}
